# SFB 1280 Subject Code Generator

## Intended use and advice on use
The [SFB 1280](https://sfb1280.ruhr-uni-bochum.de/) subject generator helps investigators and subjects to generate SFB 1280 compliant subject codes (see [SFB 1280 research data management policy](https://sfb1280.ruhr-uni-bochum.de/wp-content/uploads/2022/10/SFB1280_ResearchDataManagementPolicy_ADOPTED_20220928.pdf)). The subject code represents a pseudoanonymization and not an anonymization. 

Please be aware, that any  subject code  which is based on indirect identification features, e.g. birth name of one's mother, can be decrypted with more or less effort. In accordance with [the Ethics Committee of the German Psychological Society (DGPs)](https://zwpd.transmit.de/zwpd-dienstleistungen/zwpd-ethikkommission/vorlagen-antragstellung), the SFB 1280 recommends only the time-limited and purpose-limited use of the generated subject codes. If long-term storage is required, data should be stored under anonymous codes. Under no circumstances should data be made publicly available using the generated subject codes. 

The 11-digit SFB 1280 subject code was developed based on the 8-digit subject code originally recommended by the DGPs Ethics Committee (now [DGPs "variant 1"](https://zwpd.transmit.de/images/zwpd/dienstleistungen/ethikkommission/vorlage_codewort_anonym_v4.docx)), which generated too many duplicate subject codes in the SFB's large data sets. The 11-digit code adheres to design principles of the original code (i.e., letters of the subject's mother's maiden name are used), but results in less duplicates. It is now included as "variant 2" in the recommendations for personal code words by the DGPs Ethics Committee.

In a large test dataset with 5146 artificially created names for parents of only children and a random number for the birthday the “variant 1” code with 8-digits created 2.14% duplicates whereas the “variant 2” code with 11-digits created only 0.071% duplicates.

Instructions for generating the subject code were originally created by the SFB's INF projects and are available also as a [paper pencil version](https://gitlab.ruhr-uni-bochum.de/sfb1280/subject_code_generator/-/blob/main/paper_pencil_version/SubjectCode_SFB1280_German.pdf). A reference guide with transaltions in English is also available [here](https://gitlab.ruhr-uni-bochum.de/sfb1280/subject_code_generator/-/blob/main/paper_pencil_version/SubjectCode_SFB1280_English_ReferenceGuide.pdf).



## About this project
This project was developed to enable a faster and more reliable way to generate the code than the paper-pencil version. The official web version of this code can be found on the [SFB1280 website](https://sfb1280.ruhr-uni-bochum.de/code/) . The Subject Code Generator is available in English and in German. 

### About the project structure
This is a quick rundown on the included files of this project:
-	**ElementorBlock.html**: Most important file. This is the Elementor block which can be (wrapped in a custom -Tag) directly placed on a website.
-	**app.js**: The js-code which implements the application.
-	**SFBCodeGenerator.html**: Local test versions of the SFB 1280 website (the image Hirn_schatten.png is needed for the local version to run).
-	**.gitignore / README.md**: Files needed for git-version-control.


## License and  Reference
This work is licensed under a Creative Commons Attribution-ShareAlike 4.0 International License: https://creativecommons.org/licenses/by-sa/4.0/

Please cite as: Diers E., Pacharra, M.,  Merz, C.J., Ernst, T. & Otto, T. ....zenodo, doi: 

## Contact
If you have any questions about the Subject Code Generator, or if you have feature requests or found bugs, please contact the SFB's INF project via email: sfb1280data@rub.de

## Funding
The development of the SFB 1280 subject code generator was carried out as part of the SFB 1280 INF project, supported by the Deutsche Forschungsgemeinschaft DFG (German Research Foundation, project number project number (316803389) ).

